#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Fuchsia

extern string TimeFrameList = "5,15,60,240";
extern int SignalShift = 1;
extern string Method = "_____0_TrioAvg___1_Trix_____";
extern int Avg_Method = 0;
extern string sig = "_____Signals_____";
extern int iArrowUP = 233;
extern int iArrowDN = 234;
extern int iArrowHeight = 1;
extern double factor_SignalOffset = 0.6;
extern bool Alert_Signals = TRUE;
extern bool EMail_Signals = FALSE;
extern int maxBars = 200;
extern string IndicatorName = "___0_NONE___1_Short___2_Long____";
extern int Show_IndicatorName = 1;
string gs_152 = "Voodoo Signals";
string gs_160;
string gs_168;
double g_ibuf_176[];
double g_ibuf_180[];
double g_ibuf_184[];
double g_ibuf_188[];
double g_ibuf_192[];
int g_period_196 = 34;
bool gi_unused_200 = FALSE;
bool gi_unused_204 = FALSE;
bool gi_208 = TRUE;
int g_datetime_212;
int gi_216;
int gia_220[5];
double gd_224;
double gd_232;
double gd_240;
double gd_248;
double gd_256;
double gd_264;
double gd_272;
double gd_280;

void Get_TrioAvg(string as_0, int ai_8, int ai_12, double &ad_16, double &ad_24) {
   bool l_bool_48;
   int l_count_52;
   double ld_32 = Calculate_TrioAvg(as_0, ai_8, ai_12);
   double ld_40 = Calculate_TrioAvg(as_0, ai_8, ai_12 + 1);
   if (ld_32 == ld_40 && ld_32 != 0.0 && ld_40 != 0.0) {
      l_bool_48 = FALSE;
      l_count_52 = 0;
      while (l_bool_48 == FALSE) {
         l_count_52++;
         ld_40 = Calculate_TrioAvg(as_0, ai_8, ai_12 + 1 + l_count_52);
         l_bool_48 = ld_32 != ld_40;
      }
   }
   if (ld_32 > ld_40) ad_16 = 1;
   else ad_16 = -1;
   ad_24 = ld_32;
}

double Calculate_TrioAvg(string a_symbol_0, int a_timeframe_8, int ai_12) {
   int l_period_48 = 5;
   int l_period_52 = 13;
   int l_period_56 = 34;
   double ld_60 = 2.618;
   double ld_68 = 1.618;
   double ld_76 = 1.0;
   double ld_84 = 5.236;
   int l_ma_method_92 = 3;
   int l_applied_price_96 = 4;
   int l_digits_100 = MarketInfo(a_symbol_0, MODE_DIGITS);
   double ld_16 = ld_60 * iMA(a_symbol_0, a_timeframe_8, l_period_48, 0, l_ma_method_92, l_applied_price_96, ai_12);
   double ld_24 = ld_68 * iMA(a_symbol_0, a_timeframe_8, l_period_52, 0, l_ma_method_92, l_applied_price_96, ai_12);
   double ld_32 = ld_76 * iMA(a_symbol_0, a_timeframe_8, l_period_56, 0, l_ma_method_92, l_applied_price_96, ai_12);
   double ld_40 = (ld_16 + ld_24 + ld_32) / ld_84;
   ld_40 = NormalizeDouble(ld_40, l_digits_100);
   return (ld_40);
}

void Get_Trix(string as_0, int ai_8, int ai_12, double &ad_16, double &ad_24) {
   double ld_32;
   double ld_40;
   bool l_bool_48;
   int l_count_52;
   Calculate_Trix(as_0, ai_8, ai_12, ld_32, ld_40);
   if (ld_32 == ld_40 && ld_32 != 0.0 && ld_40 != 0.0) {
      l_bool_48 = FALSE;
      l_count_52 = 0;
      while (l_bool_48 == FALSE) {
         l_count_52++;
         Calculate_Trix(as_0, ai_8, ai_12 + l_count_52, ld_32, ld_40);
         l_bool_48 = ld_32 != ld_40;
      }
   }
   if (ld_32 > ld_40) ad_16 = 1;
   else ad_16 = -1;
   ad_24 = ld_32;
}

void Calculate_Trix(string a_symbol_0, int a_timeframe_8, int ai_12, double &ad_16, double &ad_24) {
   double lda_76[];
   double lda_80[];
   double lda_84[];
   int li_36 = 100;
   int l_period_40 = 3;
   string ls_unused_44 = "0=SMA, 1=EMA, 2=SMMA, 3=LWMA";
   int l_ma_method_52 = 1;
   int l_ma_method_56 = 1;
   int l_ma_method_60 = 1;
   string ls_unused_64 = "0=C,4=Median,5=Typical,6=Weighted";
   int l_applied_price_72 = 0;
   ArraySetAsSeries(lda_76, TRUE);
   ArraySetAsSeries(lda_80, TRUE);
   ArraySetAsSeries(lda_84, TRUE);
   ArrayResize(lda_76, Bars);
   ArrayResize(lda_80, Bars);
   ArrayResize(lda_84, Bars);
   for (int li_32 = li_36 - 2; li_32 >= 0; li_32--) lda_76[li_32] = iMA(a_symbol_0, a_timeframe_8, l_period_40, 0, l_ma_method_52, l_applied_price_72, li_32 + ai_12);
   for (li_32 = li_36 - 2 - l_period_40; li_32 >= 0; li_32--) lda_80[li_32] = iMAOnArray(lda_76, 0, l_period_40, 0, l_ma_method_56, li_32);
   li_32 = 0;
   lda_84[li_32 + 1] = iMAOnArray(lda_80, 0, l_period_40, 0, l_ma_method_60, li_32 + 1);
   lda_84[li_32] = iMAOnArray(lda_80, 0, l_period_40, 0, l_ma_method_60, li_32);
   li_32 = 0;
   ad_16 = NormalizeDouble(lda_84[li_32], Digits);
   ad_24 = NormalizeDouble(lda_84[li_32 + 1], Digits);
}

int init() {
   string ls_4;
   string ls_12;
   string ls_20;
   for (int li_0 = 1; li_0 <= 5; li_0++) gia_220[li_0] = 0;
   Get_TimeFrameListValues(TimeFrameList, gi_216, gia_220);
   IndicatorDigits(Digits);
   IndicatorBuffers(5);
   SetIndexBuffer(0, g_ibuf_176);
   SetIndexStyle(0, DRAW_ARROW, EMPTY, iArrowHeight);
   SetIndexArrow(0, iArrowUP);
   SetIndexLabel(0, NULL);
   SetIndexBuffer(1, g_ibuf_180);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, iArrowHeight);
   SetIndexArrow(1, iArrowDN);
   SetIndexLabel(1, NULL);
   SetIndexBuffer(2, g_ibuf_184);
   SetIndexBuffer(3, g_ibuf_188);
   SetIndexBuffer(4, g_ibuf_192);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexEmptyValue(2, EMPTY_VALUE);
   for (li_0 = 1; li_0 < gi_216; li_0++) gs_168 = gs_168 + Get_sPeriod(gia_220[li_0]) + ",";
   gs_168 = gs_168 + Get_sPeriod(gia_220[gi_216]);
   if (Avg_Method == 0) gs_160 = "TrioAvg";
   else
      if (Avg_Method == 1) gs_160 = "Trix";
   if (Show_IndicatorName == 0) {
      IndicatorShortName("");
      Comment("");
   } else {
      if (Show_IndicatorName == 1) {
         IndicatorShortName(gs_152);
         Comment(gs_152);
      } else {
         if (Show_IndicatorName == 2) {
            ls_4 = ", shift=" + SignalShift;
            ls_12 = gs_152 + " (" + gs_168 + ls_4 + ", " + gs_160 + ")";
            IndicatorShortName(ls_12);
            Comment(ls_12);
         }
      }
   }
   if (Period() > gia_220[1]) {
      ls_20 = "MTFTrioAvg Signals:  Current Timeframe must be <= " + Get_sPeriod(gia_220[1]);
      ls_20 = ls_20 + "  and not " + Get_sPeriod(Period()) + "!";
      Alert(ls_20);
      gi_208 = FALSE;
      return (0);
   }
   return (0);
}

int deinit() {
   Comment("");
   return (0);
}

int start() {
   int l_shift_4;
   int li_16;
   double ld_20;
   int li_28;
   if (!gi_208) return (0);
   int li_8 = IndicatorCounted();
   if (li_8 < 0) return (-1);
   if (li_8 > 0) li_8--;
   int li_12 = maxBars;
   if (li_8 > 2) li_12 = Bars - li_8 - 1;
   for (int li_0 = li_12; li_0 >= 0; li_0--) {
      g_ibuf_184[li_0] = 0;
      if (gia_220[4] > 0) {
         l_shift_4 = iBarShift(Symbol(), gia_220[4], Time[li_0], FALSE);
         if (Avg_Method == 0) Get_TrioAvg(Symbol(), gia_220[4], l_shift_4 + SignalShift, gd_272, gd_280);
         else Get_Trix(Symbol(), gia_220[4], l_shift_4 + SignalShift, gd_272, gd_280);
         if (gd_272 > 0.0) g_ibuf_184[li_0] += 1.0;
         else g_ibuf_184[li_0] += (-1.0);
      }
      if (gia_220[3] > 0) {
         l_shift_4 = iBarShift(Symbol(), gia_220[3], Time[li_0], FALSE);
         if (Avg_Method == 0) Get_TrioAvg(Symbol(), gia_220[3], l_shift_4 + SignalShift, gd_256, gd_264);
         else Get_Trix(Symbol(), gia_220[3], l_shift_4 + SignalShift, gd_256, gd_264);
         if (gd_256 > 0.0) g_ibuf_184[li_0] += 1.0;
         else g_ibuf_184[li_0] += (-1.0);
      }
      if (gia_220[2] > 0) {
         l_shift_4 = iBarShift(Symbol(), gia_220[2], Time[li_0], FALSE);
         if (Avg_Method == 0) Get_TrioAvg(Symbol(), gia_220[2], l_shift_4 + SignalShift, gd_240, gd_248);
         else Get_Trix(Symbol(), gia_220[2], l_shift_4 + SignalShift, gd_240, gd_248);
         if (gd_240 > 0.0) g_ibuf_184[li_0] += 1.0;
         else g_ibuf_184[li_0] += (-1.0);
      }
      if (gia_220[1] > 0) {
         l_shift_4 = iBarShift(Symbol(), gia_220[1], Time[li_0], FALSE);
         if (Avg_Method == 0) Get_TrioAvg(Symbol(), gia_220[1], l_shift_4 + SignalShift, gd_224, gd_232);
         else Get_Trix(Symbol(), gia_220[1], l_shift_4 + SignalShift, gd_224, gd_232);
         if (gd_224 > 0.0) g_ibuf_184[li_0] += 1.0;
         else g_ibuf_184[li_0] += (-1.0);
      }
   }
   for (li_0 = li_12; li_0 >= 0; li_0--) {
      ld_20 = iATR(Symbol(), Period(), g_period_196, 1) * factor_SignalOffset;
      li_16 = g_ibuf_184[li_0];
      g_datetime_212 = iTime(Symbol(), Period(), li_0);
      li_28 = g_ibuf_192[li_0];
      if (MathAbs(li_16) == gi_216) {
         if (li_16 != g_ibuf_188[li_0 + 1] && g_datetime_212 != li_28) {
            if (li_16 > 0) {
               g_ibuf_176[li_0] = Low[li_0] - ld_20;
               g_ibuf_180[li_0] = EMPTY_VALUE;
               if (li_0 == 0) Send_Alert(li_0, "BUY");
               g_ibuf_188[li_0] = li_16;
               g_ibuf_192[li_0] = iTime(Symbol(), Period(), li_0);
            } else {
               if (li_16 < 0) {
                  g_ibuf_176[li_0] = EMPTY_VALUE;
                  g_ibuf_180[li_0] = High[li_0] + ld_20;
                  if (li_0 == 0) Send_Alert(li_0, "SELL");
                  g_ibuf_188[li_0] = li_16;
                  g_ibuf_192[li_0] = iTime(Symbol(), Period(), li_0);
               }
            }
         } else {
            if (li_16 == g_ibuf_188[li_0 + 1]) {
               g_ibuf_188[li_0] = g_ibuf_184[li_0];
               g_ibuf_176[li_0] = EMPTY_VALUE;
               g_ibuf_180[li_0] = EMPTY_VALUE;
            }
         }
      } else {
         g_ibuf_188[li_0] = g_ibuf_184[li_0];
         g_ibuf_192[li_0] = iTime(Symbol(), Period(), li_0);
         g_ibuf_176[li_0] = EMPTY_VALUE;
         g_ibuf_180[li_0] = EMPTY_VALUE;
      }
   }
   return (0);
}

void Send_Alert(int ai_0, string as_4) {
   string ls_12;
   if (ai_0 == 0) {
      ls_12 = Symbol() + "    " + as_4 + " signal on  " + gs_168 + " (" + gs_160 + ")";
      if (Alert_Signals == TRUE) Alert(ls_12);
      if (EMail_Signals == TRUE) SendMail("MTFTrioAvg_Signals", ls_12);
   }
}

string Get_sPeriod(int ai_0) {
   if (ai_0 == 1) return ("M1");
   if (ai_0 == 5) return ("M5");
   if (ai_0 == 15) return ("M15");
   if (ai_0 == 30) return ("M30");
   if (ai_0 == 60) return ("H1");
   if (ai_0 == 240) return ("H4");
   if (ai_0 == 1440) return ("D1");
   if (ai_0 == 10080) return ("W1");
   if (ai_0 == 43200) return ("MN1");
   return ("");
}

void Get_TimeFrameListValues(string as_0, int &a_index_8, int &aia_12[5]) {
   string ls_28;
   a_index_8 = 0;
   int l_count_16 = 0;
   int li_20 = 0;
   int li_24 = 1;
   while (l_count_16 < 10 && li_24 > 0) {
      li_24 = StringFind(as_0, ",", li_20);
      if (li_24 == 0) ls_28 = StringSubstr(as_0, li_20, 0);
      else ls_28 = StringSubstr(as_0, li_20, li_24 - li_20);
      if (ls_28 != "") {
         a_index_8++;
         aia_12[a_index_8] = StrToInteger(ls_28);
      }
      l_count_16++;
      li_20 = StringFind(as_0, ",", li_20) + 1;
      if (li_20 == 0) break;
   }
}
